<?php
/*
Plugin Name: File Inspection
Plugin URI: http://hccoder.info/
Description: The plugin creates MD5 hash from every file in your blog. If your blog got hacked you can easily check which files changed, so you can fix the hacked files quickly.
Author: hccoder - Sándor Fodor
Version: 1.0
Author URI: http://hccoder.info/
*/

$plugin_title = 'File Inspection';
$plugin_url = 'file-inspection';
$plugin_menu = 'AddMenu';

if ( ! class_exists( 'PluginSkeleton' ) ) {
	if ( ! file_exists( ABSPATH.'wp-content/plugins/'.$plugin_url.'/lib/plugin.skeleton.php' ) )
		die( 'Skeleton not found!' );
		
	require_once( ABSPATH.'wp-content/plugins/'.$plugin_url.'/lib/plugin.skeleton.php' );
}

class FileInspection extends PluginSkeleton {
	
	public function PluginAdmin() {
		
		$messages = '';
		
		if ( count($_POST) && isset($_POST['DoCompare']) ) 
			$messages = $this->DoCompare();
		elseif ( count($_POST) && isset($_POST['DoCheck']) ) 
			$this->DoCheck();
				
		$last_check = get_option('last_file_inspection');
		$files_checked = get_option('last_file_inspection_counter');
		
		require( 'views/admin.php' );
	}
	
	private function DoCheck() {
		$log = "";
		$files = $this->DirectoryToArray(ABSPATH, true);
		
		foreach ( $files as $f ) {
			$log .= "$f;".md5_file($f)."\n";
		}
		
		update_option('last_file_inspection', time());
		update_option('last_file_inspection_counter', count($files));
		
		file_put_contents(ABSPATH.'wp-content/plugins/'.$this->pid.'/last_log.php', $log);
	}
	
	private function DoCompare() {
		$changed_files = array();
		$new_files = array();
		$temp_log = array();
		
		$files = $this->DirectoryToArray(ABSPATH, true);
		$last_log = file_get_contents(ABSPATH.'wp-content/plugins/'.$this->pid.'/last_log.php');
		$last_log = explode("\n", $last_log);
				
		foreach ( $last_log as $id => $row ) {
			$current = explode(';', $row);
			$temp_log[$current[0]] = $current[1];
		}
		$last_log = $temp_log;
		
		foreach ( $files as $f ) {
			if ( $f != ABSPATH.'wp-content/plugins/'.$this->pid.'/last_log.php' ) {
				if ( ! isset( $last_log[$f] ) )
					$new_files[] = $f;
				else {
					if ( $last_log[$f] != md5_file($f) )
						$changed_files[] = $f;
				}
			}
		}
		return array( 'changed_files' => $changed_files, 'new_files' => $new_files );
	}
	
	private function DirectoryToArray($directory, $recursive) {
		$array_items = array();
		if ($handle = opendir($directory)) {
			while (false !== ($file = readdir($handle))) {
				if ($file != "." && $file != "..") {
					if (is_dir($directory. "/" . $file)) {
						if($recursive) {
							$array_items = array_merge($array_items, $this->DirectoryToArray($directory. "/" . $file, $recursive));
						}
						$file = $directory . "/" . $file;
						$array_items[] = preg_replace("/\/\//si", "/", $file);
					} else {
						$file = $directory . "/" . $file;
						$array_items[] = preg_replace("/\/\//si", "/", $file);
					}
				}
			}
			closedir($handle);
		}
		return $array_items;
	}
	
}

$test = new FileInspection( $plugin_url, $plugin_title, $plugin_menu );